/**
 * 弹出选择列表插件
 * 此组件依赖 listpcker ，请在页面中先引入 mui.picker.css + mui.picker.js
 * varstion 1.0.1
 * by Houfeng
 * Houfeng@DCloud.io
 */

(function($, document) {

	//创建 DOM
	$.dom = function(str) {
		if (typeof(str) !== 'string') {
			if ((str instanceof Array) || (str[0] && str.length)) {
				return [].slice.call(str);
			} else {
				return [str];
			}
		}
		if (!$.__create_dom_div__) {
			$.__create_dom_div__ = document.createElement('div');
		}
		$.__create_dom_div__.innerHTML = str;
		return [].slice.call($.__create_dom_div__.childNodes);
	};

	var panelBuffer =   '<div class="mui-poppicker">\
	                        <div class="mui-poppicker-remind"></div>\
	                        <div class="mui-poppicker-footer">\
	                           <div class="left-text"></div>\
	                           <div class="center-text"></div>\
	                           <div class="right-text"></div>\
	                        </div>\
							<div class="mui-poppicker-body">\
							</div>\
							<div class="mui-poppicker-header">\
								<button class="mui-btn mui-poppicker-btn-cancel">取消</button>\
								<button class="mui-btn mui-btn-blue mui-poppicker-btn-ok">确定</button>\
								<div class="mui-poppicker-clear"></div>\
							</div>\
						</div>';

	var pickerBuffer = '<div class="mui-picker">\
							<div class="mui-picker-inner">\
								<div class="mui-pciker-rule mui-pciker-rule-ft"></div>\
								<ul class="mui-pciker-list">\
								</ul>\
								<div class="mui-pciker-rule mui-pciker-rule-bg"></div>\
							</div>\
						</div>';

	//定义弹出选择器类
	var PopPicker = $.PopPicker = $.Class.extend({
		//构造函数
		init: function(options) {
			var self = this;
			self.options = options || {};
			self.options.ismultiselect = self.options.ismultiselect || false; //自定义标题文字
			self.options.remindtext = self.options.remindtext || ""; //自定义标题文字
			self.options.lefttext = self.options.lefttext || ""; //自定义标题文字
			self.options.titletext = self.options.titletext || ""; //自定义标题文字
			self.options.righttext = self.options.righttext || ""; //自定义标题文字
			self.options.buttons = self.options.buttons || ['取消', '确定'];
			self.panel = $.dom(panelBuffer)[0];
			if (self.options.remindtext) {
				self.panel.querySelector(".mui-poppicker-remind").innerHTML = self.options.remindtext;
			}else{
				self.panel.querySelector(".mui-poppicker-remind").style.display = "none";
			}
			self.panel.querySelector(".left-text").innerHTML = self.options.lefttext;
			self.panel.querySelector(".center-text").innerHTML = self.options.titletext;
			self.panel.querySelector(".right-text").innerHTML = self.options.righttext;
			document.body.appendChild(self.panel);
			self.ok = self.panel.querySelector('.mui-poppicker-btn-ok');
			self.cancel = self.panel.querySelector('.mui-poppicker-btn-cancel');
			self.body = self.panel.querySelector('.mui-poppicker-body');
			self.mask = $.createMask();
			self.cancel.innerText = self.options.buttons[0];
			self.ok.innerText = self.options.buttons[1];
			self.cancel.addEventListener('tap', function(event) {
				self.hide();
			}, false);
			self.ok.addEventListener('tap', function(event) {
				if (self.callback) {
					var indexArr = self.getAllinputindexArr();
					if (self.options.ismultiselect) {
						var rs = self.callback(self.getAllSelectedItems(),indexArr);
					} else{
						var rs = self.callback(self.getSelectedItems());
					}
					if (rs !== false) {
						self.hide();
					}
				}
			}, false);
			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
			self._createPicker();
			//防止滚动穿透
			self.panel.addEventListener($.EVENT_START, function(event) {
				event.preventDefault();
			}, false);
			self.panel.addEventListener($.EVENT_MOVE, function(event) {
				event.preventDefault();
			}, false);
		},
		_createPicker: function() {
			var self = this;
			var layer = self.options.layer || 1;
			var width = (100 / layer) + '%';
			self.pickers = [];
			for (var i = 1; i <= layer; i++) {
				var pickerElement = $.dom(pickerBuffer)[0];
				pickerElement.style.width = width;
				self.body.appendChild(pickerElement);
				var picker = $(pickerElement).picker();
				self.pickers.push(picker);
				pickerElement.addEventListener('change', function(event) {
					var nextPickerElement = this.nextSibling;
					if (nextPickerElement && nextPickerElement.picker) {
						var eventData = event.detail || {};
						var preItem = eventData.item || {};
						nextPickerElement.picker.setItems(preItem.children);
					}
				}, false);
			}
		},
		//填充数据
		setData: function(data) {
			var self = this;
			data = data || [];
			self.pickers[0].setItems(data,self.options.ismultiselect);
		},
		setTitletext: function(titletext) {
			var self = this;
			self.panel.querySelector(".left-text").innerHTML = titletext;
		},
		getpickerdom: function(domclass) {
			var self = this;
			var getdom = self.panel.querySelector(domclass);
			return getdom;
		},
		//获取全部选中的项（数组）
		getAllSelectedItems: function() {
			var self = this;
			var items = [];
			var selectcheckboxArr = self.panel.querySelector('.mui-poppicker-body').querySelectorAll('input[type="checkbox"]:checked');
			var Arrlength = selectcheckboxArr.length;
			for (var i=0;i<Arrlength;i++) {
				var pickeritems = self.pickers[0].items[parseInt(selectcheckboxArr[i].parentElement.getAttribute("data-index"))];
				items.push(pickeritems || {});
			}
			return items;
		},
		//获取全部的input（数组）
		getAllinputindexArr: function() {
			var self = this;
			var items = [];
			var selectcheckboxArr = self.panel.querySelector('.mui-poppicker-body').querySelectorAll('input[type="checkbox"]:checked');
			var Arrlength = selectcheckboxArr.length;
			for (var i=0;i<Arrlength;i++) {
				var pickeritems = parseInt(selectcheckboxArr[i].parentElement.getAttribute("data-index"));
				items.push(pickeritems);
			}
			return items;
		},
		//获取全部的input（数组）
		getAllinput: function() {
			var self = this;
			var items = self.pickers[0].elementItems;
			return items;
		},
		//获取全部选中的input（数组）
		getAllSelectedinput: function() {
			var self = this;
			var items = self.panel.querySelector('.mui-poppicker-body').querySelectorAll('input[type="checkbox"]:checked');
			return items;
		},
		//获取选中的项（数组）
		getSelectedItems: function() { 
			var self = this;
			var items = [];
			for (var i in self.pickers) {
				var picker = self.pickers[i];
				items.push(picker.getSelectedItem() || {});
			}
			return items;
		},
		setAllSelectedinput: function(isSelect) {
			var self = this;
			var checkinput = self.panel.querySelector('.mui-poppicker-footer').querySelector('input[type="checkbox"]');
			checkinput.checked = isSelect;
		},
		//显示
		show: function(callback) {
			var self = this;
			self.callback = callback;
			self.mask.show();
			document.body.classList.add($.className('poppicker-active-for-page'));
			self.panel.classList.add($.className('active'));
			//处理物理返回键
			self.__back = $.back;
			$.back = function() {
				self.hide();
			};
		},
		//隐藏
		hide: function() {
			var self = this;
			if (self.disposed) return;
			self.panel.classList.remove($.className('active'));
			self.mask.close();
			document.body.classList.remove($.className('poppicker-active-for-page'));
			//处理物理返回键
			$.back=self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for (var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});

})(mui, document);